

//#define _XTAL_FREQ 	40000000  //40MHz
#define _XTAL_FREQ 	10000000  //10MHz
#define __PICCPRO__

// CONFIG1H
#pragma config OSC = HS         // Oscillator Selection bits (HS oscillator)
#pragma config FCMEN = OFF      // Fail-Safe Clock Monitor Enable bit (Fail-Safe Clock Monitor disabled)
#pragma config IESO = OFF       // Internal External Oscillator Switchover bit (Internal External Switchover mode disabled)

// CONFIG2L
#pragma config PWRTEN = OFF     // Power-up Timer Enable bit (PWRT disabled)
#pragma config BOREN = OFF      // Brown-out Reset Enable bits (Brown-out Reset disabled)
// BORV = No Setting

// CONFIG2H
#pragma config WDTEN = OFF      // Watchdog Timer Enable bit (WDT disabled (control is placed on the SWDTEN bit))
#pragma config WDPS = 32768     // Watchdog Timer Postscale Select bits (1:32768)
#pragma config WINEN = OFF      // Watchdog Timer Window Enable bit (WDT window disabled)

// CONFIG3L
#pragma config PWMPIN = OFF     // PWM output pins Reset state control (PWM outputs disabled upon Reset (default))
#pragma config LPOL = HIGH      // Low-Side Transistors Polarity (PWM0, 2, 4 and 6 are active-high)
#pragma config HPOL = HIGH      // High-Side Transistors Polarity (PWM1, 3, 5 and 7 are active-high)
#pragma config T1OSCMX = ON     // Timer1 Oscillator MUX (Low-power Timer1 operation when microcontroller is in Sleep mode)

// CONFIG3H
#pragma config FLTAMX = RC1     // FLTA MUX bit (FLTA input is multiplexed with RC1)
#pragma config SSPMX = RC7      // SSP I/O MUX bit (SCK/SCL clocks and SDA/SDI data are multiplexed with RC5 and RC4, respectively. SDO output is multiplexed with RC7.)
#pragma config PWM4MX = RB5     // PWM4 MUX bit (PWM4 output is multiplexed with RB5)
#pragma config EXCLKMX = RC3    // TMR0/T5CKI External clock MUX bit (TMR0/T5CKI external clock input is multiplexed with RC3)
#pragma config MCLRE = ON       // MCLR Pin Enable bit (Enabled)

// CONFIG4L
#pragma config STVREN = OFF     // Stack Full/Underflow Reset Enable bit (Stack full/underflow will not cause Reset)
#pragma config LVP = OFF        // Low-Voltage ICSP Enable bit (Low-voltage ICSP disabled)

// CONFIG5L
#pragma config CP0 = OFF        // Code Protection bit (Block 0 (000200-000FFFh) not code-protected)
#pragma config CP1 = OFF        // Code Protection bit (Block 1 (001000-001FFF) not code-protected)
#pragma config CP2 = OFF        // Code Protection bit (Block 2 (002000-002FFFh) not code-protected)
#pragma config CP3 = OFF        // Code Protection bit (Block 3 (003000-003FFFh) not code-protected)

// CONFIG5H
#pragma config CPB = OFF        // Boot Block Code Protection bit (Boot Block (000000-0001FFh) not code-protected)
#pragma config CPD = OFF        // Data EEPROM Code Protection bit (Data EEPROM not code-protected)

// CONFIG6L
#pragma config WRT0 = OFF       // Write Protection bit (Block 0 (000200-000FFFh) not write-protected)
#pragma config WRT1 = OFF       // Write Protection bit (Block 1 (001000-001FFF) not write-protected)
#pragma config WRT2 = OFF       // Write Protection bit (Block 2 (002000-002FFFh) not write-protected)
#pragma config WRT3 = OFF       // Write Protection bit (Block 3 (003000-003FFFh) not write-protected)

// CONFIG6H
#pragma config WRTC = OFF       // Configuration Register Write Protection bit (Configuration registers (300000-3000FFh) not write-protected)
#pragma config WRTB = OFF       // Boot Block Write Protection bit (Boot Block (000000-0001FFh) not write-protected)
#pragma config WRTD = OFF       // Data EEPROM Write Protection bit (Data EEPROM not write-protected)

// CONFIG7L
#pragma config EBTR0 = OFF      // Table Read Protection bit (Block 0 (000200-000FFFh) not protected from table reads executed in other blocks)
#pragma config EBTR1 = OFF      // Table Read Protection bit (Block 1 (001000-001FFF) not protected from table reads executed in other blocks)
#pragma config EBTR2 = OFF      // Table Read Protection bit (Block 2 (002000-002FFFh) not protected from table reads executed in other blocks)
#pragma config EBTR3 = OFF      // Table Read Protection bit (Block 3 (003000-003FFFh) not protected from table reads executed in other blocks)

// CONFIG7H
#pragma config EBTRB = OFF      // Boot Block Table Read Protection bit (Boot Block (000000-0001FFh) not protected from table reads executed in other blocks)

//#define max_pwm 2200 //period in microseconds
//#define min_pwm 800

#define PWM_MD LATDbits.LD4
#define PWM_EL LATDbits.LD5
#define PWM_ER LATDbits.LD6
#define PWM_TH LATDbits.LD7
#define PWM_TT LATBbits.LB0
#define PWM_A1 LATBbits.LB1
#define PWM_A2 LATBbits.LB2
#define PWM_A3 LATBbits.LB3


//#define BUTTON_DEBUG LATAbits.LA3
#define BUTTON_DEBUG PORTAbits.RA3
/*#define LED_RED LATAbits.LA5
#define LED_YELLOW LATEbits.LE0
#define LED_GREEN LATEbits.LE1
#define LED_WHITE LATEbits.LE2*/
#define LED_RED LATEbits.LE2
#define LED_YELLOW LATEbits.LE1
#define LED_GREEN LATEbits.LE0
#define LED_WHITE LATAbits.LA5
#define ROCKET LATAbits.LA4

#define OPERATIONS_PER_SEC 2500000 // _XTAL_FREQ/4       //for 10MHz mode
#define OPERATIONS_PER_MSEC 2500   // _XTAL_FREQ/4000
#define OPERATIONS_PER_USEC 3      // _XTAL_FREQ/4000000
#define OPERATIONS_PER_10USEC 25

#define MRF49XA_SPI_DELAY 5

/*#define OPERATIONS_PER_SEC 10000000 // _XTAL_FREQ/4    //for 40MHz mode
#define OPERATIONS_PER_MSEC 10000   // _XTAL_FREQ/4000
#define OPERATIONS_PER_USEC 10      // _XTAL_FREQ/4000000
#define OPERATIONS_PER_10USEC 100

#define MRF49XA_SPI_DELAY 20*/

#define BUTTON_CHECK_DELAY 300000
#define BUTTON_CHECK_DELAY_MS 20

#define DEVICE_ID 0xCA
#define TARGET_DEVICE_ID 0xC9

#define MAIN_MOTOR_SPEED 0x6E //110
#define EL_ANGLE 0x6F //111
#define ER_ANGLE 0x70 //112
#define TH_ANGLE 0x71 //113
#define TT_ANGLE 0x72 //114

#define ELERONS_ADJUST_ANGLE 0x73 //115
#define TH_ADJUST_ANGLE 0x74 //116
#define TT_ADJUST_ANGLE 0x75 //117

#define RADIO_RED_LED 0x76 //118
#define RADIO_YELLOW_LED 0x77 //119
#define RADIO_GREEN_LED 0x78 //120
#define RADIO_WHITE_LED 0x79 //121
#define RADIO_ROCKET 0x7A //122

#define RADIO_DEBUG_BUTTON 0x7B //123

#define MAIN_MOTOR_MAX_SPEED_VALUE 0x7C //124

#define _TRUE 1
#define _FALSE 0

#define RWM_delay 1000

#include <xc.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
//#include "adc.h"

//#define __delay_us(x) _delay((unsigned long)((x)*(_XTAL_FREQ/4000000.0)))
//#define __delay_ms(x) _delay((unsigned long)((x)*(_XTAL_FREQ/4000.0)))






