
#include "Headers/MRF49XA.h"
//#include "Headers/common_config.h"


//unsigned char packet_to_send[] = { 0x01, 0x01, 0x01, 0x01 };
//unsigned char packet_received[] = { 0x01, 0x01, 0x01, 0x01 };

//unsigned char packet_to_send[] = { 0x01, 0x01 };
//unsigned char packet_received[] = { 0x01, 0x01 };

unsigned char main_motor_sp = 0;
unsigned char el_ang = 0;
unsigned char er_ang = 0;
unsigned char th_ang = 0;
unsigned char tt_ang = 0;

unsigned char elerons_adj = 0;
unsigned char th_adj = 0;
unsigned char tt_adj = 0;

unsigned char rocket_counter = 0;

static unsigned char button_debug_pressed = 0;

unsigned char checksum;

unsigned int i = 0;
unsigned int counter = 0;

int status = 0;

void InitializeDevice()
{
    TRISA = 0b00001000; //0 - output; 1 - input; button input
    TRISAbits.RA3 = 1;
    TRISB = 0b00000000;
    //SSPCONbits.SSPEN = 0;
    SSPCON = 0b00000000; //disable SPI port for RC7
    RCSTA = 0b00000000; //disable USART port fr RC7
    
    TRISC = 0b00010000; //spi input
    TRISD = 0b00000000;
    TRISE = 0b00000000;

    ANSEL0 = 0b00000000;
    ANSEL1 = 0b00000000;

    PORTA = 0b00000000; //values on ports
    PORTB = 0b00000000;
    PORTC = 0b00000000;
    PORTD = 0b00000000;
    PORTE = 0b00000000;
}

void ConfigureMainMotor()
{
    LED_RED = 1;
    LED_YELLOW = 1;
    LED_GREEN = 1;
    LED_WHITE = 1;
    for(counter = 0; counter < 100; counter++) //pwm initialization legacy
    {
        PWM_MD = 1;
        DelayMS(1);
        PWM_MD = 0;
        DelayMS(19);
    }
    for(counter = 0; counter < 100; counter++)
    {
        PWM_MD = 1;
        DelayMS(2);
        PWM_MD = 0;
        DelayMS(18);
    }
    LED_RED = 0;
    LED_YELLOW = 0;
    LED_GREEN = 0;
    LED_WHITE = 0;
}

/*void CalculateChecksum()
{
    checksum = 0;
    for(i = 0; i < 8; ++i)
        checksum = checksum + (((packet_received[BYTE_DEVICE_ID])>>i)&0x01);
    for(i = 0; i < 8; ++i)
        checksum = checksum + (((packet_received[BYTE_FUNCTION_ID])>>i)&0x01);
    for(i = 0; i < 8; ++i)
        checksum = checksum + (((packet_received[BYTE_VALUE])>>i)&0x01);
    packet_to_send[3] = checksum;
}*/

void ParsePacketReceived()
{
        switch(packet_received[BYTE_FUNCTION_ID])
        {
            case MAIN_MOTOR_SPEED:
            {
                main_motor_sp = packet_received[BYTE_VALUE];
                break;
            }
            case EL_ANGLE:
            {
                el_ang = packet_received[BYTE_VALUE];
                break;
            }
            case ER_ANGLE:
            {
                er_ang = packet_received[BYTE_VALUE];
                break;
            }
            case TH_ANGLE:
            {
                th_ang = packet_received[BYTE_VALUE];
                break;
            }
            case TT_ANGLE:
            {
                tt_ang = packet_received[BYTE_VALUE];
                break;
            }
            case ELERONS_ADJUST_ANGLE:
            {
                elerons_adj = packet_received[BYTE_VALUE];
                break;
            }
            case TH_ADJUST_ANGLE:
            {
                th_adj = packet_received[BYTE_VALUE];
                break;
            }
            case TT_ADJUST_ANGLE:
            {
                tt_adj = packet_received[BYTE_VALUE];
                break;
            }
            case RADIO_RED_LED:
            {
                LED_RED = ((packet_received[BYTE_VALUE] > 0) ? 1 : 0);
                break;
            }
            case RADIO_YELLOW_LED:
            {
                LED_YELLOW = ((packet_received[BYTE_VALUE] > 0) ? 1 : 0);
                break;
            }
            case RADIO_GREEN_LED:
            {
                LED_GREEN = ((packet_received[BYTE_VALUE] > 0) ? 1 : 0);
                break;
            }
            case RADIO_WHITE_LED:
            {
                LED_WHITE = ((packet_received[BYTE_VALUE] > 0) ? 1 : 0);
                break;
            }
            case RADIO_ROCKET:
            {
                rocket_counter = 0;
                ROCKET = 1;
                LED_WHITE = 1;
                break;
            }
        }
}

/*
 * 
 */
void main()
{
    DelayMS(500);
    InitializeDevice();
    ConfigureMainMotor();
    MRF49XA_Init();
    
    while(1)
    {
        //Start main loop iteration
        
        //----------------------------------------------------------------------Button handler
        if((BUTTON_DEBUG == 1) && !button_debug_pressed)
        {
            DelayMS(BUTTON_CHECK_DELAY_MS);
            if(BUTTON_DEBUG == 1)
            {
                button_debug_pressed = 1; //... button is pressed
                LED_YELLOW = 1;
                packet_to_send[BYTE_FUNCTION_ID] = RADIO_DEBUG_BUTTON; //RADIO_GREEN_LED;
                packet_to_send[BYTE_VALUE] = 0x11;
                MRF49XA_Send_Packet2(packet_to_send);
            }
        } else if((BUTTON_DEBUG == 0) && button_debug_pressed) {
            DelayMS(BUTTON_CHECK_DELAY_MS);
            if(BUTTON_DEBUG == 0)
            {
                button_debug_pressed = 0; //... button is left
                LED_YELLOW = 0;
            }
        }
        //----------------------------------------------------------------------PWMs
        PWM_MD = 1;
        _delay(OPERATIONS_PER_MSEC); //1msec
        for(counter = 0; counter < main_motor_sp; counter++)
            _delay(OPERATIONS_PER_10USEC);
        PWM_MD = 0;

        PWM_EL = 1;
        _delay(OPERATIONS_PER_MSEC); //1msec
        for(counter = 0; counter < el_ang; counter++)
            _delay(OPERATIONS_PER_10USEC);
        PWM_EL = 0;

        PWM_ER = 1;
        _delay(OPERATIONS_PER_MSEC); //1msec
        for(counter = 0; counter < er_ang; counter++)
            _delay(OPERATIONS_PER_10USEC);
        PWM_ER = 0;

        PWM_TH = 1;
        _delay(OPERATIONS_PER_MSEC); //1msec
        for(counter = 0; counter < th_ang; counter++)
            _delay(OPERATIONS_PER_10USEC);
        PWM_TH = 0;

        PWM_TT = 1;
        _delay(OPERATIONS_PER_MSEC); //1msec
        for(counter = 0; counter < tt_ang; counter++)
            _delay(OPERATIONS_PER_10USEC);
        PWM_TT = 0;
        //----------------------------------------------------------------------Rocket
        if(rocket_counter < 200) // 5ms(e.g. min PWMs delay) * 200 = 1sec
        {
            rocket_counter++;
        } else if(rocket_counter < 220) //for reliability
        {
            ROCKET = 0;
            LED_WHITE = 0;
            rocket_counter = 250;
        }
        //----------------------------------------------------------------------Receive job
        status = MRF49XA_Receive_Packet2();
        if(status == PACKET_RECEIVED)
        {
            ParsePacketReceived();
        }
        //Finish main loop iteration
    }
    
}


