/********************************************************************
 Software License Agreement:

 The software supplied herewith by Microchip Technology Incorporated
 (the "Company") for its PIC(R) Microcontroller is intended and
 supplied to you, the Company's customer, for use solely and
 exclusively on Microchip PIC Microcontroller products. The
 software is owned by the Company and/or its supplier, and is
 protected under applicable copyright laws. All rights are reserved.
 Any use in violation of the foregoing restrictions may subject the
 user to criminal sanctions under applicable laws, as well as to
 civil liability for the breach of the terms and conditions of this
 license.

 THIS SOFTWARE IS PROVIDED IN AN "AS IS" CONDITION. NO WARRANTIES,
 WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING, BUT NOT LIMITED
 TO, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
 PARTICULAR PURPOSE APPLY TO THIS SOFTWARE. THE COMPANY SHALL NOT,
 IN ANY CIRCUMSTANCES, BE LIABLE FOR SPECIAL, INCIDENTAL OR
 CONSEQUENTIAL DAMAGES, FOR ANY REASON WHATSOEVER.
 *******************************************************************/

#ifndef APP_DEVICE_CDC_BASIC_H
#define APP_DEVICE_CDC_BASIC_H

#include <stdbool.h>
#include <stddef.h>

#include "MRF49XA.h"
//#include "usb/usb_device_hid.h"
#include "usb/usb_device_cdc.h"
#include "fixed_address_memory.h"
#include "../Headers/usb_config.h"

static signed char elerons_adj = 0;
static signed char th_adj = 0;
static signed char tt_adj = 0;

unsigned char is_allowed = 0;

static unsigned char is_usb_connected = 0;
static unsigned char is_interrupt_prohibited = 0;
/********************************************************************
 * My functions
********************************************************************/
void SendMainMotorSpeed2(unsigned char speed);
void SendEleronsValue2(unsigned char valv);
void SendTHValue2(unsigned char val);
void SendTTValue2(unsigned char val);
void SendRocketLaunch();
void SendLedRed(unsigned char val);
void SendLedYellow(unsigned char val);
void SendLedGreen(unsigned char val);
void SendLedWhite(unsigned char val);
void ReadADJValues();
void WriteADJValues();
void InitializeServomotors();
void MainTasks();

/*********************************************************************
* Function: void APP_DeviceCustomHIDInitialize(void);
*
* Overview: Initializes the Custom HID demo code
*
* PreCondition: None
*
* Input: None
*
* Output: None
*
********************************************************************/
//void APP_DeviceCustomHIDInitialize();
void APP_DeviceCDCBasicDemoInitialize();

/*********************************************************************
* Function: void APP_DeviceCustomHIDStart(void);
*
* Overview: Starts running the Custom HID demo.
*
* PreCondition: The device should be configured into the configuration
*   that contains the custome HID interface.  The APP_DeviceCustomHIDInitialize()
*   function should also have been called before calling this function.
*
* Input: None
*
* Output: None
*
********************************************************************/
void APP_DeviceCustomHIDStart();




#endif
