
#define _XTAL_FREQ 	48000000  //48MHz
#define __PICCPRO__

#pragma config PLLDIV = 4       // PLL Prescaler Selection bits (Divide by 3 (12 MHz oscillator input))
#pragma config CPUDIV = OSC1_PLL2 // System Clock Postscaler Selection bits ([Primary Oscillator Src: /1][96 MHz PLL Src: /2])
#pragma config USBDIV = 2       // USB Clock Selection bit (used in Full-Speed USB mode only; UCFG:FSEN = 1) (USB clock source comes directly from the primary oscillator block with no postscale)

// CONFIG1H
#pragma config FOSC = HSPLL_HS        // Oscillator Selection bits (HS oscillator (HS))
#pragma config FCMEN = OFF      // Fail-Safe Clock Monitor Enable bit (Fail-Safe Clock Monitor disabled)
#pragma config IESO = OFF       // Internal/External Oscillator Switchover bit (Oscillator Switchover mode disabled)

// CONFIG2L
#pragma config PWRT = OFF       // Power-up Timer Enable bit (PWRT disabled)
#pragma config BOR = OFF        // Brown-out Reset Enable bits (Brown-out Reset disabled in hardware and software)
#pragma config BORV = 2         // Brown-out Reset Voltage bits (Minimum setting)
#pragma config VREGEN = ON     // USB Voltage Regulator Enable bit (USB voltage regulator disabled)

// CONFIG2H
#pragma config WDT = OFF        // Watchdog Timer Enable bit (WDT disabled (control is placed on the SWDTEN bit))
#pragma config WDTPS = 32768    // Watchdog Timer Postscale Select bits (1:32768)

// CONFIG3H
#pragma config CCP2MX = OFF      // CCP2 MUX bit (CCP2 input/output is multiplexed with RC1)
#pragma config PBADEN = OFF      // PORTB A/D Enable bit (PORTB<4:0> pins are configured as analog input channels on Reset)
#pragma config LPT1OSC = OFF    // Low-Power Timer 1 Oscillator Enable bit (Timer1 configured for higher power operation)
#pragma config MCLRE = OFF       // MCLR Pin Enable bit (MCLR pin enabled; RE3 input pin disabled)

// CONFIG4L
#pragma config STVREN = OFF     // Stack Full/Underflow Reset Enable bit (Stack full/underflow will not cause Reset)
#pragma config LVP = OFF        // Single-Supply ICSP Enable bit (Single-Supply ICSP disabled)
#pragma config XINST = OFF      // Extended Instruction Set Enable bit (Instruction set extension and Indexed Addressing mode disabled (Legacy mode))

// CONFIG5L
#pragma config CP0 = OFF        // Code Protection bit (Block 0 (000800-001FFFh) is not code-protected)
#pragma config CP1 = OFF        // Code Protection bit (Block 1 (002000-003FFFh) is not code-protected)
#pragma config CP2 = OFF        // Code Protection bit (Block 2 (004000-005FFFh) is not code-protected)

// CONFIG5H
#pragma config CPB = OFF        // Boot Block Code Protection bit (Boot block (000000-0007FFh) is not code-protected)
#pragma config CPD = OFF        // Data EEPROM Code Protection bit (Data EEPROM is not code-protected)

// CONFIG6L
#pragma config WRT0 = OFF       // Write Protection bit (Block 0 (000800-001FFFh) is not write-protected)
#pragma config WRT1 = OFF       // Write Protection bit (Block 1 (002000-003FFFh) is not write-protected)
#pragma config WRT2 = OFF       // Write Protection bit (Block 2 (004000-005FFFh) is not write-protected)

// CONFIG6H
#pragma config WRTC = OFF       // Configuration Register Write Protection bit (Configuration registers (300000-3000FFh) are not write-protected)
#pragma config WRTB = OFF       // Boot Block Write Protection bit (Boot block (000000-0007FFh) is not write-protected)
#pragma config WRTD = OFF       // Data EEPROM Write Protection bit (Data EEPROM is not write-protected)

// CONFIG7L
#pragma config EBTR0 = OFF      // Table Read Protection bit (Block 0 (000800-001FFFh) is not protected from table reads executed in other blocks)
#pragma config EBTR1 = OFF      // Table Read Protection bit (Block 1 (002000-003FFFh) is not protected from table reads executed in other blocks)
#pragma config EBTR2 = OFF      // Table Read Protection bit (Block 2 (004000-005FFFh) is not protected from table reads executed in other blocks)

// CONFIG7H
#pragma config EBTRB = OFF      // Boot Block Table Read Protection bit (Boot block (000000-0007FFh) is not protected from table reads executed in other blocks)

//#define max_pwm 2200 //period in microseconds
//#define min_pwm 800


/*#define BUTTON_ON_OFF_MAIN_MOTOR        LATBbits.LB5
#define BUTTON_ROCKET                   LATAbits.LA0
#define BUTTON_MAIN_MOTOR_MAX           LATBbits.LB6
#define BUTTON_ADJUST_SERVOMOTORS       LATAbits.LA1*/

#define BUTTON_ON_OFF_MAIN_MOTOR        PORTBbits.RB5
#define BUTTON_ROCKET                   PORTBbits.RB3 //PORTAbits.RA0
#define BUTTON_MAIN_MOTOR_MAX           PORTBbits.RB6
#define BUTTON_ADJUST_SERVOMOTORS       PORTBbits.RB1 //PORTAbits.RA1

#define LED_RED         LATBbits.LB0
#define LED_YELLOW      LATCbits.LC7
#define LED_GREEN       LATCbits.LC6



#define OPERATIONS_PER_SEC 12000000 // _XTAL_FREQ/4
#define OPERATIONS_PER_MSEC 12000   // _XTAL_FREQ/4000
#define OPERATIONS_PER_USEC 12      // _XTAL_FREQ/4000000

#define MRF49XA_SPI_DELAY 24

#define BUTTON_CHECK_DELAY 30000
#define BUTTON_CHECK_DELAY_MS 20

#define PACKET_SEND_DELAY_MS 15 //Delay between packet sendings

#define DEVICE_ID 0xC9
#define TARGET_DEVICE_ID 0xCA

#define MAIN_MOTOR_SPEED 0x6E //110
#define EL_ANGLE 0x6F //111
#define ER_ANGLE 0x70 //112
#define TH_ANGLE 0x71 //113
#define TT_ANGLE 0x72 //114

#define ELERONS_ADJUST_ANGLE 0x73 //115
#define TH_ADJUST_ANGLE 0x74 //116
#define TT_ADJUST_ANGLE 0x75 //117

#define RADIO_RED_LED 0x76 //118
#define RADIO_YELLOW_LED 0x77 //119
#define RADIO_GREEN_LED 0x78 //120
#define RADIO_WHITE_LED 0x79 //121
#define RADIO_ROCKET 0x7A //122

#define RADIO_DEBUG_BUTTON 0x7B //123

#define MAIN_MOTOR_MAX_SPEED_VALUE 0x4B //75

#define ANALOG_MIN_DIFFERENCE 2
#define ANALOG_MAX_DIFFERENCE 50
#define ANALOG_VALUE_JUMP_DETECTOR 1800
#define MEASURE_ADC_RETRIES 10
#define MEASURE_ADC_DELAY_US 100

#define _TRUE 1
#define _FALSE 0

#define RWM_delay 1000

#define USB_BUFFER_SIZE 4

#include <xc.h>

//#define __delay_us(x) _delay((unsigned long)((x)*(_XTAL_FREQ/4000000.0)))
//#define __delay_ms(x) _delay((unsigned long)((x)*(_XTAL_FREQ/4000.0)))


