
//#include "./Headers/system.h"

#include "Headers/MainTasks.h"

#include "Headers/usb/usb.h"
#include "Headers/usb/usb_device.h"
//#include "Headers/usb/usb_device_hid.h"
#include "Headers/usb/usb_device_cdc.h"
/*
 * 
 */

void InitializeDevice()
{
    T1CON = 0b00000000;
    //CCP1CON = 0b00000000;
    CCP2CON = 0b00000000;
    UTRDIS = 0;

    TRISA = 0b00101111; //0 - output; 1 - input; button input
    TRISB = 0b01101110;
    TRISC = 0b00000010; //SPI input

    ADCON1 = 0b00000110; //0b00001111
    ADCON2 = 0b10110100;  //Right justified

    //EECON1 = 0b00000100; //Configuring EEPROM
    EECON1bits.EEPGD = 0;
    EECON1bits.CFGS = 0;
    EECON1bits.WRERR = 0;
    EECON1bits.FREE = 0;
    EECON1bits.WREN = 1;

    PORTA = 0b00000000; //values on ports
    PORTB = 0b00000000;
    PORTC = 0b00000001; //SPI_CS = 1 by default
}


unsigned int startup_counter = 0;

void main()
{
    DelayMS(500);
    InitializeDevice();
    is_allowed = 1;
    LED_RED = 1;
    LED_YELLOW = 1;
    LED_GREEN = 1;
    DelayS(1);
    MRF49XA_Init(); //To perform this initialisation first - to avoid potential dammage of USB interrupts
    ReadADJValues();

    USBDeviceInit();  
    USBDeviceAttach();
    //InitializeServomotors();
    LED_RED = 0;
    LED_YELLOW = 0;
    LED_GREEN = 0;
    while(1)
    {
        MainTasks();
        //#if defined(USB_POLLING)
            // Interrupt or polling method.  If using polling, must call
            // this function periodically.  This function will take care
            // of processing and responding to SETUP transactions
            // (such as during the enumeration process when you first
            // plug in).  USB hosts require that USB devices should accept
            // and process SETUP packets in a timely fashion.  Therefore,
            // when using polling, this function should be called
            // regularly (such as once every 1.8ms or faster** [see
            // inline code comments in usb_device.c for explanation when
            // "or faster" applies])  In most cases, the USBDeviceTasks()
            // function does not take very long to execute (ex: <100
            // instruction cycles) before it returns.
            //USBDeviceTasks();
        //#endif
        if( USBGetDeviceState() < CONFIGURED_STATE )
        {
            // Jump back to the top of the while loop.
            //is_usb_connected = 0;
            continue;
        }
        //is_usb_connected = 1;
        if( USBIsDeviceSuspended()== true )
        {
            // Jump back to the top of the while loop.
            //is_usb_connected = 0;
            continue;
        }
        //is_usb_connected = 1;
        //CDCTxService();
    }//end while
}//end main


bool USER_USB_CALLBACK_EVENT_HANDLER(USB_EVENT event, void *pdata, uint16_t size)
{
    switch((int)event)
    {
        case EVENT_TRANSFER:
            break;

        case EVENT_SOF:
            /* We are using the SOF as a timer to time the LED indicator.  Call
             * the LED update function here. */
            break;

        case EVENT_SUSPEND:
            /* Update the LED status for the suspend event. */
            break;

        case EVENT_RESUME:
            /* Update the LED status for the resume event. */
            break;

        case EVENT_CONFIGURED:
            /* When the device is configured, we can (re)initialize the demo
             * code. */
            //APP_DeviceCustomHIDInitialize(); //For HID protocol
            APP_DeviceCDCBasicDemoInitialize();
            break;

        case EVENT_SET_DESCRIPTOR:
            break;

        case EVENT_EP0_REQUEST:
            /* We have received a non-standard USB request.  The HID driver
             * needs to check to see if the request was for it. */
            USBCheckCDCRequest();
            break;

        case EVENT_BUS_ERROR:
            break;

        case EVENT_TRANSFER_TERMINATED:
            break;

        default:
            break;
    }
    return true;
}

/*void interrupt SYS_InterruptHigh(void)
{
    #if defined(USB_INTERRUPT)
        USBDeviceTasks();
    #endif
}*/